3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
8 # 2011 Free Software Foundation
9 # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License. A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
21 # If the first parameter reads --patch, the second parameter is considered
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
42 # Default options used when updating (none).
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
51 ######## Anything below shouldn't be changed by regular users.
53 # Arrange for the value of $0 to be available for functions
56 # This function prints its arguments to standard output unless
60 if [ -z "$silent" ]; then
65 # This function prints a list of all generated files, along with their
66 # dependencies. Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies
() {
69 sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
71 fixincludes
/configure
: fixincludes
/configure.ac fixincludes
/aclocal.
m4
72 fixincludes
/config.h.
in: fixincludes
/configure.ac fixincludes
/aclocal.
m4
74 intl
/plural.c
: intl
/plural.y
75 intl
/configure
: intl
/configure.ac intl
/aclocal.
m4
76 intl
/config.h.
in: intl
/configure.ac intl
/aclocal.
m4
77 # Now, proceed to gcc automatically generated files
78 gcc
/configure
: gcc
/configure.ac
79 gcc
/cstamp-h.
in: gcc
/configure.ac
80 gcc
/config.
in: gcc
/cstamp-h.
in
81 gcc
/fixinc
/fixincl.x
: gcc
/fixinc
/fixincl.tpl gcc
/fixinc
/inclhack.def
82 gcc
/config
/aarch64
/aarch64-tune.md
: gcc
/config
/aarch64
/aarch64-cores.def gcc
/config
/aarch64
/gentune.sh
83 gcc
/config
/arm
/arm-tune.md
: gcc
/config
/arm
/arm-cores.def gcc
/config
/arm
/gentune.sh
84 gcc
/config
/arm
/arm-tables.opt
: gcc
/config
/arm
/arm-arches.def gcc
/config
/arm
/arm-cores.def gcc
/config
/arm
/arm-fpus.def gcc
/config
/arm
/genopt.sh
85 gcc
/config
/avr
/avr-tables.opt
: gcc
/config
/avr
/avr-mcus.def gcc
/config
/avr
/genopt.sh
86 gcc
/config
/avr
/t-multilib
: gcc
/config
/avr
/avr-mcus.def gcc
/config
/avr
/genmultilib.
awk
87 gcc
/config
/c6x
/c6x-tables.opt
: gcc
/config
/c6x
/c6x-isas.def gcc
/config
/c6x
/genopt.sh
88 gcc
/config
/c6x
/c6x-sched.md
: gcc
/config
/c6x
/c6x-sched.md.
in gcc
/config
/c6x
/gensched.sh
89 gcc
/config
/c6x
/c6x-mult.md
: gcc
/config
/c6x
/c6x-mult.md.
in gcc
/config
/c6x
/genmult.sh
90 gcc
/config
/m68k
/m68k-tables.opt
: gcc
/config
/m68k
/m68k-devices.def gcc
/config
/m68k
/m68k-isas.def gcc
/config
/m68k
/m68k-microarchs.def gcc
/config
/m68k
/genopt.sh
91 gcc
/config
/mips
/mips-tables.opt
: gcc
/config
/mips
/mips-cpus.def gcc
/config
/mips
/genopt.sh
92 gcc
/config
/rs6000
/rs6000-tables.opt
: gcc
/config
/rs6000
/rs6000-cpus.def gcc
/config
/rs6000
/genopt.sh
93 gcc
/config
/tilegx
/mul-tables.c
: gcc
/config
/tilepro
/gen-mul-tables.cc
94 gcc
/config
/tilepro
/mul-tables.c
: gcc
/config
/tilepro
/gen-mul-tables.cc
95 # And then, language-specific files
96 gcc
/cp
/cfns.h
: gcc
/cp
/cfns.gperf
97 gcc
/java
/keyword.h
: gcc
/java
/keyword.gperf
99 # Without this, _Pragma3.c can have a false negative.
100 gcc
/testsuite
/gcc.dg
/cpp
/_Pragma3.c
: gcc
/testsuite
/gcc.dg
/cpp
/mi1c.h
101 # Similarly, without this, you will see:
102 # direct2s.c:35: warning: current file is older than direct2.c
103 gcc
/testsuite
/gcc.dg
/cpp
/direct2s.c
: gcc
/testsuite
/gcc.dg
/cpp
/direct2.c
105 lto-plugin
/configure
: lto-plugin
/configure.ac lto-plugin
/aclocal.
m4
106 lto-plugin
/Makefile.
in: lto-plugin
/Makefile.am lto-plugin
/aclocal.
m4
107 # And libraries, at last
108 libbanshee
/configure
: libbanshee
/configure.ac
109 libmudflap
/configure
: libmudflap
/configure.ac
110 libobjc
/configure
: libobjc
/configure.ac
111 zlib
/aclocal.
m4: zlib
/configure.ac zlib
/acinclude.
m4
112 zlib
/Makefile.
in: zlib
/Makefile.am zlib
/configure.ac zlib
/aclocal.
m4
113 zlib
/configure
: zlib
/configure.ac zlib
/aclocal.
m4
114 fastjar
/aclocal.
m4: fastjar
/configure.ac
115 fastjar
/Makefile.
in: fastjar
/Makefile.am fastjar
/configure.ac fastjar
/aclocal.
m4
116 fastjar
/configure
: fastjar
/configure.ac fastjar
/aclocal.
m4
117 boehm-gc
/aclocal.
m4: boehm-gc
/configure.ac
118 boehm-gc
/Makefile.
in: boehm-gc
/Makefile.am boehm-gc
/configure.ac boehm-gc
/aclocal.
m4
119 boehm-gc
/configure
: boehm-gc
/configure.ac boehm-gc
/aclocal.
m4
120 libada
/configure
: libada
/configure.ac
121 libffi
/aclocal.
m4: libffi
/configure.ac libffi
/acinclude.
m4
122 libffi
/Makefile.
in: libffi
/Makefile.am libffi
/configure.ac libffi
/aclocal.
m4
123 libffi
/configure
: libffi
/configure.ac libffi
/aclocal.
m4
124 libffi
/fficonfig.h.
in: libffi
/configure.ac libffi
/aclocal.
m4
125 libgfortran
/aclocal.
m4: libgfortran
/configure.ac libgfortran
/acinclude.
m4
126 libgfortran
/Makefile.
in: libgfortran
/Makefile.am libgfortran
/configure.ac libgfortran
/aclocal.
m4
127 libquadmath
/configure
: libquadmath
/configure.ac libquadmath
/aclocal.
m4
128 libquadmath
/aclocal.
m4: libquadmath
/configure.ac libquadmath
/acinclude.
m4
129 libquadmath
/Makefile.
in: libquadmath
/Makefile.am libquadmath
/configure.ac libgfortran
/aclocal.
m4
130 libgfortran
/configure
: libgfortran
/configure.ac libgfortran
/aclocal.
m4
131 libjava
/aclocal.
m4: libjava
/configure.ac
132 libjava
/Makefile.
in: libjava
/Makefile.am libjava
/configure.ac libjava
/aclocal.
m4
133 libjava
/configure
: libjava
/configure.ac libjava
/aclocal.
m4
134 libjava
/libltdl
/aclocal.
m4: libjava
/libltdl
/configure.ac libjava
/libltdl
/acinclude.
m4
135 libjava
/libltdl
/Makefile.
in: libjava
/libltdl
/Makefile.am libjava
/libltdl
/configure.ac libjava
/libltdl
/aclocal.
m4
136 libjava
/libltdl
/configure
: libjava
/libltdl
/configure.ac libjava
/libltdl
/aclocal.
m4
137 libjava
/libltdl
/config-h.
in: libjava
/libltdl
/configure.ac libjava
/libltdl
/aclocal.
m4
138 libcpp
/aclocal.
m4: libcpp
/configure.ac
139 libcpp
/Makefile.
in: libcpp
/configure.ac libcpp
/aclocal.
m4
140 libcpp
/configure
: libcpp
/configure.ac libcpp
/aclocal.
m4
141 libgomp
/aclocal.
m4: libgomp
/configure.ac libgomp
/acinclude.
m4
142 libgomp
/Makefile.
in: libgomp
/Makefile.am libgomp
/aclocal.
m4
143 libgomp
/testsuite
/Makefile.
in: libgomp
/testsuite
/Makefile.am libgomp
/aclocal.
m4
144 libgomp
/configure
: libgomp
/configure.ac libgomp
/aclocal.
m4
145 libgomp
/config.h.
in: libgomp
/configure.ac libgomp
/aclocal.
m4
146 libitm
/aclocal.
m4: libitm
/configure.ac libitm
/acinclude.
m4
147 libitm
/Makefile.
in: libitm
/Makefile.am libitm
/aclocal.
m4
148 libitm
/testsuite
/Makefile.
in: libitm
/testsuite
/Makefile.am libitm
/aclocal.
m4
149 libitm
/configure
: libitm
/configure.ac libitm
/aclocal.
m4
150 libitm
/config.h.
in: libitm
/configure.ac libitm
/aclocal.
m4
151 libatomic
/aclocal.
m4: libatomic
/configure.ac libatomic
/acinclude.
m4
152 libatomic
/Makefile.
in: libatomic
/Makefile.am libatomic
/aclocal.
m4
153 libatomic
/testsuite
/Makefile.
in: libatomic
/testsuite
/Makefile.am libatomic
/aclocal.
m4
154 libatomic
/configure
: libatomic
/configure.ac libatomic
/aclocal.
m4
155 libatomic
/auto-config.h.
in: libatomic
/configure.ac libatomic
/aclocal.
m4
156 libsanitizer
/aclocal.
m4: libsanitizer
/configure.ac libsanitizer
/acinclude.
m4
157 libsanitizer
/Makefile.
in: libsanitizer
/Makefile.am libsanitizer
/aclocal.
m4
158 libsanitizer
/configure
: libsanitizer
/configure.ac libsanitizer
/aclocal.
m4
159 libsanitizer
/asan
/Makefile.
in: libsanitizer
/asan
/Makefile.am libsanitizer
/aclocal.
m4
160 libsanitizer
/interception
/Makefile.
in: libsanitizer
/interception
/Makefile.am libsanitizer
/aclocal.
m4
161 libsanitizer
/sanitizer_common
/Makefile.
in: libsanitizer
/sanitizer_common
/Makefile.am libsanitizer
/aclocal.
m4
162 libvtv
/aclocal.
m4: libvtv
/configure.ac libvtv
/acinclude.
m4
163 libvtv
/Makefile.
in: libvtv
/Makefile.am libvtv
/aclocal.
m4
164 libvtv
/configure
: libvtv
/configure.ac libvtv
/aclocal.
m4
165 libcilkrts
/aclocal.
m4: libcilkrts
/configure.ac
166 libcilkrts
/Makefile.
in: libcilkrts
/Makefile.am
167 libcilkrts
/configure
: libcilkrts
/configure.ac
169 Makefile.
in: Makefile.tpl Makefile.def
170 configure
: configure.ac config
/acx.
m4
175 # This function touches generated files such that the ``end'' user does
176 # not have to rebuild them.
179 echo 'all: \' > Makefile.$$
180 files_and_dependencies | sed 's
, .
*, \\,' >> Makefile.$$
181 echo '; @true
' >> Makefile.$$
182 files_and_dependencies | sed 's
, ,: ,' >> Makefile.$$
183 files_and_dependencies | sed 's
, .
*, \\,' >> Makefile.$$
184 echo ':' >> Makefile.$$
185 echo ' @
for f
in $? $@
; do test -f $
$f ||
exit 0; done; \' >> Makefile.$$
186 echo ' echo Touching $@...; \' >> Makefile.$$
187 chat ' echo Touching $@...
1>&2; \' >> Makefile.$$
188 echo ' touch $@' >> Makefile.$$
189 files_and_dependencies |
sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
191 # We would have to explicitly shut off the "Entering... Leaving..."
192 # messages through "--no-print-directory" to handle the case when
193 # we were called from a recursive invocation (i.e. "$(MAKE)" in a
194 # Makefile, not just make). Passing only "-s" doesn't help then,
195 # because make has helpfully added "-w" to MAKEFLAGS automatically.
196 # Unfortunately we do not require GNU make other than for building
197 # and testing, so let's just grep known text explicitly echoed by
199 while ${MAKE-make} -s -f Makefile.$$ all |
grep Touching
> /dev
/null
; do
206 # Whenever we update the tree or install a patch, we may be modifying
207 # this script. By re-execing it, we ensure that the appropriate
208 # dependencies and rules will be used.
209 touch_files_reexec
() {
210 chat
"Adjusting file timestamps"
211 exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
214 # This functions applies a patch to an existing tree.
217 echo "Applying patch file $1"
220 gzip -d -c "$1" |
patch -p1 ;;
222 bzip2 -d -c "$1" |
patch -p1 ;;
230 # Check whether this indeed looks like a local tree.
231 if [ ! -f gcc
/version.c
]; then
232 echo "This does not seem to be a GCC tree!"
244 # First of all, check whether we are going to process a patch.
246 if test "$#" != 2; then
247 echo "$1" expects only one argument
>&2
255 if test "$#" != 1; then
256 echo "$1" does not expect any argument
>&2
264 if test "$#" != 1; then
265 echo "$1" does not expect any argument
>&2
268 files_and_dependencies |
sed 's/ /: /'
273 sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
278 -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
284 # Check for known version control systems.
286 GCC_GIT
=${GCC_GIT-${GIT-git}}
288 elif [ -d .hg
]; then
289 GCC_HG
=${GCC_HG-${HG-hg}}
291 elif [ -d .svn
]; then
292 GCC_SVN
=${GCC_SVN-${SVN-svn}}
295 echo "This does not seem to be a GCC GIT/HG/SVN tree!"
299 # Check command-line options
300 if [ x
"${1}"x
= x
"--nostdflags"x
]; then
303 set -- $UPDATE_OPTIONS ${1+"$@"}
308 chat
"Updating GIT tree"
310 $GCC_GIT diff --quiet --exit-code HEAD
311 if [ $?
-ne 0 ]; then
312 echo "Attempting to update a dirty git tree!" >&2
313 echo "Commit or stash your changes first and retry." >&2
317 $GCC_GIT pull
${silent+-q} --rebase ${1+"$@"}
318 if [ $?
-ne 0 ]; then
320 echo "git pull of full tree failed." >&2
324 revision
=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
325 branch
=`$GCC_GIT name-rev --name-only HEAD || :`
329 chat
"Updating HG tree"
331 # Add -q so untracked files aren't listed.
332 if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
333 echo "Attempting to update a dirty hg tree!" >&2
334 echo "Commit or revert your changes first and retry." >&2
338 # Check for mq extension. mq patches must be popped so tip has
339 # been converted from the SVN tree.
340 if [ -d .hg
/patches
] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
341 # FIXME: Perhaps pop queue instead? We could do that since we
342 # know the tree is clean.
343 echo "Attempting to update hg tree with mq patches applied!" >&2
344 echo "Pop your patches first and retry." >&2
348 # Update tree, but make sure to only pull the default branch.
349 # Otherwise all branches in the upstream repo are added, even if
350 # only a single one has been cloned.
351 $GCC_HG pull
${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
352 if [ $?
-ne 0 ]; then
354 echo "hg pull of full tree failed." >&2
358 # Update tree. Needs to be done separately from pull so
359 # gcc_update -rREV works.
360 $GCC_HG update
${silent+-q} ${1+"$@"}
361 if [ $?
-ne 0 ]; then
363 echo "hg update of full tree failed." >&2
367 # Extract SVN revision corresponding to parents, as stored by
368 # hg convert. Before hg 1.4.3, there's no template keyword
369 # corresponding to the extra: tag, so need to use hg log --debug
370 # to extract the info.
371 parents
=`$GCC_HG parents --template '{rev}'`
372 convert_revision
=`$GCC_HG log --debug -r$parents | \
373 sed -ne "/^extra:.*convert_revision=svn:/ {
377 revision
=`echo $convert_revision | sed -e 's/.*@//'`
378 branch
=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
382 chat
"Updating SVN tree"
384 $GCC_SVN ${silent+-q} --non-interactive update
${1+"$@"}
385 if [ $?
-ne 0 ]; then
387 echo "SVN update of full tree failed." >&2
391 revision
=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
392 branch
=`$GCC_SVN info | sed -ne "/^URL:/ {
401 rm -f LAST_UPDATED gcc
/REVISION
404 echo "`TZ=UTC date` (revision $revision)"
406 echo "[$branch revision $revision]" > gcc
/REVISION